/*
 * Ext JS Library 2.1
 * Copyright(c) 2006-2008, Ext JS, LLC.
 * licensing@extjs.com
 * 
 * http://extjs.com/license
 */ 
Ext.BLANK_IMAGE_URL = 'theme/images/default/s.gif';
var mefillColor = {r:255,g:0,b:0,hex:'#ff0000',visible:'visible',color:'#ff0000',opacity:'1',gradient:'no'};
var mestrokeColor = {r:0,g:0,b:255,hex:'#000000',visible:'visible',color:'#ff0000',width:'1',opacity:'1',gradient:'no'};
 
var fillhex="#ff0000";  
var squarecont=0;
var squarerows=6;
var squarecols=6;  
var squarelist=new Array(squarerows);  
var filldraw=true;
var strokedraw=true;
var mode_render_fill=2;
var mode_render_stroke=2;

var prevselect_fill='no-fill-gradient';
var prevselect_stroke='no-stroke-gradient'; 

for (i = 0; i < squarerows; i++)
 {
     squarelist[i]=new Array(squarecols);
 }

function rgb2hex(r,g,b){                
 var rh= toHex(r);
 var gh= toHex(g);
 var bh= toHex(b);  
 return '#'+rh + '' + gh + '' + bh;
// document.getElementById('inputfillhex').value=fillhex;
 //parent.c.editCommand('mefillcolor', color);
}
 
function hex2rgb(hex)
   {
     var regexp = new RegExp('^#?([a-f0-9]{2})([a-f0-9]{2})([a-f0-9]{2})$');
     var match = hex.toLowerCase().match(regexp);
  
      if (match)
      {
          var rgb = new Array(parseInt(match[1], 16), parseInt(match[2], 16), parseInt(match[3], 16));
          return(rgb);
      }
      else
      {
          var rgb = new Array(0,0,0);
          return(rgb);
      }
  }
  
function toHex(color){
	color=parseInt(color).toString(16);
	return color.length<2?"0"+color:color;
} 

function squareDump(r,g,b,container) {  
 squareArray(r,g,b);
 for (i = 0; i < squarerows; i++)
   {
  for (j = 0; j < squarecols; j++) 
   { 
        document.getElementById(container+i+'_'+j).style.backgroundColor = squarelist[i][j];
   } 
   squarecont++;            
 }              
 squarecont=0;
} 



function squareArray(r,g,b) {     
 
  var l00_05=ccnp(r,g,b,0,0,0,(squarerows+0));
 var color00_05=l00_05.split("_"); 
 
 var l05_55=ccnp(255,255,255,255-r,255-g,255-b,(squarerows+0));
 var color05_55=l05_55.split("_"); 

 var cols0, cols5, rowy;
 var cad='';
 for(var i=0;i<squarerows;i++){
        cols0=color00_05[i].split(",");
        cols5=color05_55[i].split(",");
        //for(var j=0;j<squarecols;j++){
        rowy=ccnprmtrc(parseInt(cols0[0]),parseInt(cols0[1]),parseInt(cols0[2]),parseInt(cols5[0]),parseInt(cols5[1]),parseInt(cols5[2]),squarecols+0);
        squarelist[i]=rowy.split("_");
        cad+=squarelist[i].join("  ");
        //}        
 }

//alert(l00_60);  
//document.getElementById('texta').value=cad;
}
function ccnp(a,b,c,d,e,f,nPartes){
	var q=0
	 var crdnds='';
	 var h = 1 / (nPartes);
	 var k = (1 - q)* a +  q * d;
	 var l = (1 - q)* b +  q * e;
	 var m = (1 - q)* c + q * f;
	// crdnds += k +" "+ l +" "+ m +", "+ R;
      for (var i=0; i<=(nPartes) ;i++)
       { 
	 k = (1 - q)* a +  q * d;
	 l = (1 - q)* b +  q * e;
	 m = (1 - q)* c +  q * f;
	q = q + h;
	if(i==(nPartes)){
	   crdnds+=''+ parseInt(Math.round(k)) +","+ parseInt(Math.round(l)) +","+ parseInt(Math.round(m)) +"" ;
	 }else{
  	   crdnds+=''+ parseInt(Math.round(k)) +","+ parseInt(Math.round(l)) +","+ parseInt(Math.round(m)) +"_";

	 }   
       }  
	return  crdnds;
}
function ccnprmtrc(a,b,c,d,e,f,nPartes){
	var q=0
	 var crdnds='';
	 var h = 1 / (nPartes);
	 var k = (1 - q)* a +  q * d;
	 var l = (1 - q)* b +  q * e;
	 var m = (1 - q)* c + q * f;
	// crdnds += k +" "+ l +" "+ m +", "+ R;
      for (var i=0; i<=(nPartes) ;i++)
       { 
	 k = (1 - q)* a +  q * d;
	 l = (1 - q)* b +  q * e;
	 m = (1 - q)* c +  q * f;
	q = q + h;
	if(i==(nPartes)){
	   crdnds+='rgb('+ parseInt(Math.round(k)) +","+ parseInt(Math.round(l)) +","+ parseInt(Math.round(m)) +")" ;
	 }else{
  	   crdnds+='rgb('+ parseInt(Math.round(k)) +","+ parseInt(Math.round(l)) +","+ parseInt(Math.round(m)) +")_";

	 }   
       }  
	return  crdnds;
} 


/**
 * Converts an HSL color value to RGB. Conversion formula adapted from
 * http://en.wikipedia.org/wiki/HSL_color_space. Assumes h, s, and l are
 * contained in the set [0, 1] and returns r, g, and b in the set [0, 255].
 *
 * @param   {Number}    h       The hue
 * @param   {Number}    s       The saturation
 * @param   {Number}    l       The lightness
 * @return  {Array}             The RGB representation
 */
var hslToRgb = function(h, s, l){
    var r, g, b;

    if(s == 0){
        r = g = b = l; // achromatic
    }else{
        function hue2rgb(p, q, t){
            if(t < 0) t += 1;
            if(t > 1) t -= 1;
            if(t < 1/6) return p + (q - p) * 6 * t;
            if(t < 1/2) return q;
            if(t < 2/3) return p + (q - p) * (2/3 - t) * 6;
            return p;
        };

        var q = l < 0.5 ? l * (1 + s) : l + s - l * s;
        var p = 2 * l - q;
        r = hue2rgb(p, q, h + 1/3);
        g = hue2rgb(p, q, h);
        b = hue2rgb(p, q, h - 1/3);
    }

    return [parseInt(r * 255), parseInt(g * 255), parseInt(b * 255)];
};  
/**
 * Converts an RGB color value to HSL. Conversion formula adapted from
 * http://en.wikipedia.org/wiki/HSL_color_space. Assumes r, g, and b are
 * contained in the set [0, 255] and returns h, s, and l in the set [0, 1].
 *
 * @param   {Number}    r       The red color value
 * @param   {Number}    g       The green color value
 * @param   {Number}    b       The blue color value
 * @return  {Array}             The HSL representation
 */
var rgbToHsl = function(r, g, b){
    r /= 255, g /= 255, b /= 255;
    var max = Math.max(r, g, b), min = Math.min(r, g, b);
    var h, s, l = (max + min) / 2;

    if(max == min){
        h = s = 0; // achromatic
    }else{
        var d = max - min;
        s = l > 0.5 ? d / (2 - max - min) : d / (max + min);
        switch(max){
            case r: h = (g - b) / d + (g < b ? 6 : 0); break;
            case g: h = (b - r) / d + 2; break;
            case b: h = (r - g) / d + 4; break;
        }
        h /= 6;
    }

    return [h, s, l];
};
function selectSquare(x,y,container){   
   movecolors=0;
  //$("#square"+x+"_"+y).css("border", "1px solid #000");
   //  $("#square"+x+"_"+y).mouseover(function(){
      
   // }).mouseout(function(){
     //  $("#square"+x+"_"+y).css("border", "0px solid #000");
   // });  
   var cadcolor=document.getElementById('square_'+container+(x)+'_'+y).style.backgroundColor
   //document.getElementById('texta').value=cadcolor; 
   var treecolors=GetString(cadcolor, '(', ')');
   
   //OPCTION? 
   var rgb=treecolors.split(', '); 
   //squareDump(rgb[0],rgb[1],rgb[2],'square_'+container);
   if(container=='stroke')
    {
        Ext.get('width-slider-stroke-mask').applyStyles({'background-color':'rgb('+rgb[0]+','+rgb[1]+','+rgb[2]+')'});
        //--document.forms.formstrokedata.mestrokecolor.value=rgb[0]+','+rgb[1]+','+rgb[2];
        mestrokeColor.r=rgb[0]; 
        mestrokeColor.g=rgb[1]; 
        mestrokeColor.b=rgb[2];
        mestrokeColor.hex=rgb2hex(rgb[0],rgb[1],rgb[2]);
        c.editCommand('linecolor',mestrokeColor.hex);
    }
     else
    {
         //--document.forms.formfilldata.mefillcolor.value=rgb[0]+','+rgb[1]+','+rgb[2];
         mefillColor.r=rgb[0]; mefillColor.g=rgb[1];mefillColor.b=rgb[2];
         mefillColor.hex=rgb2hex(rgb[0],rgb[1],rgb[2]);
         c.editCommand('fillcolor',mefillColor.hex);

    }
   Ext.get('opacity-slider-'+container).applyStyles({'background-color':'rgb('+rgb[0]+','+rgb[1]+','+rgb[2]+')'});
   Ext.get(container+'-square').applyStyles({'background-color':'rgb('+rgb[0]+','+rgb[1]+','+rgb[2]+')'});
   
    //document.getElementById('texta').value=rgb[0]+' '+rgb[1]+' '+rgb[2]; 
 /*   if(actualEdit ==1){
      fillMemory();    
    }else{
     strokeMemory();   
    }
        $('.slider1').SliderSetValues([[Math.round(rgb[0]*45/255),0]]);  
        $('.slider2').SliderSetValues([[Math.round(rgb[1]*45/255),0]]);
        $('.slider3').SliderSetValues([[Math.round(rgb[2]*45/255),0]]);  //-(mefillColor.b*45/255)
 */
     

} 
function setbe(num,id)
 { 
  if(num == 1)
   { 
     if(filldraw==true)
      {
       
        Ext.get(id).dom.src ='img/theme/images/no.gif';  
        filldraw=false;  
        //--document.forms.formfilldata.fillvisible.value='hidden';
         mefillColor.visible='hidden';
         c.editCommand('fillcolor','none');
       // $('#tape').show("slow"); 
        
      }
       else 
      {
        Ext.get(id).dom.src ='img/theme/images/ok.gif';   
        filldraw=true; 
        //--document.forms.formfilldata.fillvisible.value='visible';
        mefillColor.visible='visible';
         c.editCommand('fillcolor',mefillColor.hex);
       // $('#tape').hide("slow"); 
      }
   }

  if( num== 2)  // stroke
   {
     if(strokedraw==true)
      {
        Ext.get(id).dom.src ='img/theme/images/no.gif';     
        strokedraw=false; 
        //--document.forms.formstrokedata.strokevisible.value='hidden';
        mestrokeColor.visible='hidden'; 
        c.editCommand('linecolor','none');
        //$('#tape').show("slow"); 
      }
       else 
      {
        Ext.get(id).dom.src ='img/theme/images/ok.gif';   
        strokedraw=true; 
        //--document.forms.formstrokedata.strokevisible.value='visible'; 
        mestrokeColor.visible='visible';          
        c.editCommand('linecolor',mestrokeColor.hex);
        //$('#tape').hide("slow"); 
      }
   }
 }                
 
///////////

function onColorChange(){
c.lineColor =mestrokeColor.hex;
c.fillColor = mefillColor.hex;
c.lineWidth =mestrokeColor.width;
c.lineOpac = mestrokeColor.opacity;
c.fillOpac = mefillColor.opacity;
if(mefillColor.visible=='hidden')
{
c.fillColor = 'none';
}
if(mestrokeColor.visible=='hidden')
{
c.lineColor = 'none';
}
return;
}
 
///////////

function setProperties(){   
   
   Ext.get('opacity-slider-fill').applyStyles({'background-color':'rgb('+mefillColor.r+','+mefillColor.g+','+mefillColor.b+')'});
   Ext.get('fill-square').applyStyles({'background-color':'rgb('+mefillColor.r+','+mefillColor.g+','+mefillColor.b+')'});
   squareDump(mefillColor.r,mefillColor.g,mefillColor.b,'square_fill'); 
   
   Ext.get('opacity-slider-stroke').applyStyles({'background-color':'rgb('+mestrokeColor.r+','+mestrokeColor.g+','+mestrokeColor.b+')'});
   Ext.get('width-slider-stroke-mask').applyStyles({'background-color':'rgb('+mestrokeColor.r+','+mestrokeColor.g+','+mestrokeColor.b+')'});
   Ext.get('stroke-square').applyStyles({'background-color':'rgb('+mestrokeColor.r+','+mestrokeColor.g+','+mestrokeColor.b+')'});
   squareDump(mestrokeColor.r,mestrokeColor.g,mestrokeColor.b,'square_stroke');  

}                      
//////////


function GetString(source, start, end){
var st = source.indexOf(start) + start.length;
var en = source.indexOf(end, start);
 return source.substring(st, en);//trimAll(source.substring(st, en));
}




var basicColors=new Array(" ",
"ff0000","ff8800","ffcc00",
"ffff00","ccff00","88ff00","00ff00","00ff88","00ffcc","00ffff",
 "00ccff","0088ff","0000ff","8800ff","cc00ff","ff00ff","ff00cc","ff0088"
); 

var str=''
for(var a=1;a<basicColors.length;a++){
 str+='<span id="s'+a+'" style="background-color:'+basicColors[a]+'; width:2px;font-size:0.95em">.</span>';
} 
var str1=''
for(var a=basicColors.length;a>0;a--){
 str1+='<span id="s'+a+'" style="background-color:'+basicColors[a]+'; width:2px;font-size:8px">&nbsp;</span>';
} 


  var str2='';
  var contx=0;
  var conty=0;
  var unitx=8;  
  var unity=8;
  var widthsq='width: '+unitx+'px;';
  for (i = 0; i < squarerows; i++) 
   { 
    contx=0;
    for (j = 0; j < squarecols; j++) 
     { 
        str2+='<div class="colorFillSquare" id="square_fill'+i+'_'+j+'" style="'+widthsq+' left:'+contx+'px; top:'+conty+'px;" onmouseover="this.style.borderWidth=\'1px\'; this.style.zIndex=100" onmouseout="this.style.borderWidth=\'0px\';this.style.zIndex=0" onclick="selectSquare('+i+','+j+',\'fill\')"></div>';
        contx+=unitx;
     } 
     conty+=unity;
   } 

 
  var str3='';
  var contx=0;
  var conty=0;
  var unitx=8;  
  var unity=8;
  var widthsq='width: '+unitx+'px;';
  for (i = 0; i < squarerows; i++) 
   { 
    contx=0;
    for (j = 0; j < squarecols; j++) 
     { 
        str3+='<div class="colorStrokeSquare" id="square_stroke'+i+'_'+j+'" style="'+widthsq+' left:'+contx+'px; top:'+conty+'px;" onmouseover="this.style.borderWidth=\'1px\'; this.style.zIndex=100" onmouseout="this.style.borderWidth=\'0px\';this.style.zIndex=0" onclick="selectSquare('+i+','+j+',\'stroke\')"></div>';
        contx+=unitx;
     } 
     conty+=unity;
   } 

///////////////////// 

   var str4='';
       str4+='<span id="linear-fill-gradient" class="toolboxItem" title="Linear gradient" onmouseout="select(this,0,0)" onmouseover="select(this,1,0)" onclick="select(this,2,0)"><img  src="theme/images/gradient_linear.gif"></span>&nbsp;&nbsp;';
       str4+='<span id="radial-fill-gradient" class="toolboxItem" title="Radial gradient" onmouseout="select(this,0,1)" onmouseover="select(this,1,1)" onclick="select(this,2,1)"><img src="theme/images/gradient_radial.gif"></span>&nbsp;&nbsp;';
       str4+='<span id="no-fill-gradient" class="toolboxItem" title="No gradient" onmouseout="select(this,0,2)" onmouseover="select(this,1,2)" onclick="select(this,2,2)"><img src="theme/images/gradient_no.gif"></span>';

/////////////////////

   var str5='';
       str5+='<span id="linear-stroke-gradient" class="toolboxItem" title="Linear gradient" onmouseout="select(this,0,0)" onmouseover="select(this,1,0)" onclick="select(this,2,0)"><img  src="theme/images/gradient_linear.gif"></span>&nbsp;&nbsp;';
       str5+='<span id="radial-stroke-gradient" class="toolboxItem" title="Radial gradient" onmouseout="select(this,0,1)" onmouseover="select(this,1,1)" onclick="select(this,2,1)"><img src="theme/images/gradient_radial.gif"></span>&nbsp;&nbsp;';
       str5+='<span id="no-stroke-gradient" class="toolboxItem" title="No gradient" onmouseout="select(this,0,2)" onmouseover="select(this,1,2)" onclick="select(this,2,2)"><img src="theme/images/gradient_no.gif"></span>';

/////////////////////

 var str6='';   //<form name="formfilldata">
 str6+='<input type="text" class="field" name="fillvisible" title="Fill visible" value="visible"  size="2">';
 str6+='<input type="text" class="field" name="fillcolor" title="Fill color"value="255,0,0" size="2">';  
 str6+='<input type="text" class="field" name="fillopacity" title="Fill opacity" value="100" size="2">';
 str6+='<input type="text" class="field" name="fillgradient" title="Fill gradient" value="no" size="2">';
  str6+='';

 var str7=''; // <form name="formstrokedata">
 str7+='<input type="text" class="field" title="Stroke visible" name="strokevisible" value="visible"  size="2">';
 str7+='<input type="text" class="field" title="Stroke color" name="strokecolor" value="0,0,0" size="2">';  
  str7+='<input type="text" class="field" title="Stroke width" name="strokewidth" value="1" size="2">';
 str7+='<input type="text" class="field" title="Stroke opacity" name="strokeopacity" value="100" size="2">';
   str7+='<input type="text" class="field" title="Stroke gradienr" name="strokegradient" value="no" size="2">';

  str7+='';


//ONREADY

Ext.onReady(function() {

      
   //  Ext.get("mefillColor").dom.innerHTML=(str);
   //   Ext.get("mestrokeColor").dom.innerHTML=(str1); 
  


    
   Ext.get("fillContainer").dom.innerHTML=(str2);      
   Ext.get("strokeContainer").dom.innerHTML=(str3); 
   //Ext.get("toolbox_fill").dom.innerHTML=(str4);
   //Ext.get("toolbox_stroke").dom.innerHTML=(str5); 
  // Ext.get("divformfill").dom.innerHTML=(str6); 
   //Ext.get("divformstroke").dom.innerHTML=(str7); 

   
   Ext.get('fill-square').applyStyles({'background-color':'rgb(255,0,0)'});
   Ext.get('stroke-square').applyStyles({'background-color':'rgb(0,0,0)'});
  //Ext.get('no-stroke-gradient').applyStyles({'background-position':'0 0'});  
  //Ext.get('no-fill-gradient').applyStyles({'background-position':'0 0'});
  
         var color=hslToRgb(0, 1, 0.5); 
         squareDump(color[0],color[1],color[2],'square_fill');  
 
        var color=hslToRgb(0, 0, 0); 
        squareDump(color[0],color[1],color[2],'square_stroke');  
         
     //console.log('The windows has been loaded','fill-square' );      
     new Ext.Slider({
        renderTo: 'slider-fill',
        width: 62, 
        height: 5,
        minValue: -1,
        maxValue: 360, 
        value: 10,
        plugins: new Ext.ux.SliderFillColor()
    });
       new Ext.Slider({
        renderTo: 'opacity-slider-fill',
        width: 55,
        minValue: 0,
        maxValue: 100,
        value: 100,
        plugins: new Ext.ux.SliderOpacityFill()
    });     
        
        new Ext.Slider({
        renderTo: 'slider-stroke',
        width: 62,
        minValue: -1,
        maxValue: 360,
        value: -1,
        plugins: new Ext.ux.SliderStrokeColor()
    });   
   
      new Ext.Slider({
        renderTo: 'opacity-slider-stroke',
        width: 57,
        minValue: 0,
        maxValue: 100,
        value: 100, 
        plugins: new Ext.ux.SliderOpacityStroke()
    });  
      new Ext.Slider({
        renderTo: 'width-slider-stroke',
        width: 57,
        minValue: 0,
        maxValue: 50, 
        value: 1,
        plugins: new Ext.ux.SliderWidth()
    }); 

   
}); 

//  end ONREADY





Ext.ux.SliderFillColor = Ext.extend(Ext.Tip, {
    minWidth: 10,
    offsets : [0, -10],
    init : function(slider){
        slider.on('dragstart', this.onSlide, this);
        slider.on('drag', this.onSlide, this);
        slider.on('dragend', this.hide, this);
        slider.on('destroy', this.destroy, this);
    },

    onSlide : function(slider){
        //this.show();
        //this.doAutoWidth();
        //this.el.alignTo(slider.thumb, 'b-t?', this.offsets); 
         if(this.getText(slider)<0 || this.getText(slider)>359)
          {  
            var color=new Array();  
            color[0]='0';
            color[1]='0';
            color[2]='0'; 

            if(this.getText(slider)>359)
             { 
 
              color[0]='245';
              color[1]='245';
              color[2]='245'; 
             }  
            Ext.get('fill-square').applyStyles({'background-color':'rgb('+color[0]+','+color[1]+','+color[2]+')'});
            Ext.get('opacity-slider-fill').applyStyles({'background-color':'rgb('+color[0]+','+color[1]+','+color[2]+')'});
      
          }
           else
          {  
              var color=hslToRgb((this.getText(slider)/359), 1, 0.5); 
             Ext.get('fill-square').applyStyles({'background-color':'rgb('+color[0]+','+color[1]+','+color[2]+')'});
             Ext.get('opacity-slider-fill').applyStyles({'background-color':'rgb('+color[0]+','+color[1]+','+color[2]+')'});
             //var color=hslToRgb((this.getText(slider)/359), 1, 0.5);       
          }
       
         squareDump(color[0],color[1],color[2],'square_fill'); 
         //Ext.get("fillcolor").dom.innerHTML=(color[0]+','+color[1]+','+color[2]);
         //--document.forms.formfilldata.fillcolor.value=color[0]+','+color[1]+','+color[2];
         mefillColor.r=color[0]; mefillColor.g=color[1]; mefillColor.b=color[2];
         mefillColor.hex=rgb2hex(color[0],color[1],color[2]);
         c.editCommand('fillcolor',mefillColor.hex);

         //Ext.get("squareFill0_0").applyStyles({'background-color':'rgb('+color[0]+','+color[1]+','+color[2]+')'}); 
       // Ext.get("squareFill0_5").applyStyles({'background-color':'rgb(255,255,255)'});
        //Ext.get("squareFill5_5").applyStyles({'background-color':'rgb('+Math.abs(color[0]-255)+','+Math.abs(color[1]-255)+','+Math.abs(color[2]-255)+')'});
          //      Ext.get("squareFill5_0").applyStyles({'background-color':'rgb(0,0,0)'});
        //Ext.get("text").dom.innerHTML=color[0];
        
    },

    getText : function(slider){ 
       return slider.getValue();
    }
});



 
Ext.ux.SliderStrokeColor = Ext.extend(Ext.Tip, {
    minWidth: 10,
    offsets : [0, -10],
    init : function(slider){
        slider.on('dragstart', this.onSlide, this);
        slider.on('drag', this.onSlide, this);
        slider.on('dragend', this.hide, this);
        slider.on('destroy', this.destroy, this);
    },

    onSlide : function(slider){
        //this.show();
        //this.doAutoWidth();
        //this.el.alignTo(slider.thumb, 'b-t?', this.offsets);
        if(this.getText(slider)<0 || this.getText(slider)>359)
          {  
            var color=new Array();  
            color[0]='0';
            color[1]='0';
            color[2]='0'; 

            if(this.getText(slider)>359)
             { 
 
              color[0]='245';
              color[1]='245';
              color[2]='245'; 
             }  
            Ext.get('stroke-square').applyStyles({'background-color':'rgb('+color[0]+','+color[1]+','+color[2]+')'});
            Ext.get('opacity-slider-stroke').applyStyles({'background-color':'rgb('+color[0]+','+color[1]+','+color[2]+')'});
             Ext.get('width-slider-stroke-mask').applyStyles({'background-color':'rgb('+color[0]+','+color[1]+','+color[2]+')'});

          }
           else
          { 
              var color=hslToRgb((this.getText(slider)/359), 1, 0.5); 
             Ext.get('stroke-square').applyStyles({'background-color':'rgb('+color[0]+','+color[1]+','+color[2]+')'});
             Ext.get('opacity-slider-stroke').applyStyles({'background-color':'rgb('+color[0]+','+color[1]+','+color[2]+')'});
             Ext.get('width-slider-stroke-mask').applyStyles({'background-color':'rgb('+color[0]+','+color[1]+','+color[2]+')'});

             /*Ext.get('stroke-square').applyStyles({'background-color':'hsl('+this.getText(slider)+',100%,50%)'});
             Ext.get('opacity-slider-stroke').applyStyles({'background-color':'hsl('+this.getText(slider)+',100%,50%)'});
             var color=hslToRgb((this.getText(slider)/359), 1, 0.5);
             Ext.get('width-slider-stroke-mask').applyStyles({'background-color':'hsl('+this.getText(slider)+',100%,50%)'});
            */
          }
   
        
         
        //Ext.get('stroke-square').applyStyles({'background-color':'hsl('+this.getText(slider)+',100%,50%)'});
        //Ext.get('opacity-slider-stroke').applyStyles({'background-color':'hsl('+this.getText(slider)+',100%,50%)'});

        //var color=hslToRgb((this.getText(slider)/359), 1, 0.5); 
        squareDump(color[0],color[1],color[2],'square_stroke'); 
        //--document.forms.formstrokedata.strokecolor.value=color[0]+','+color[1]+','+color[2];
        mestrokeColor.r=color[0]; mestrokeColor.g=color[1]; mestrokeColor.b=color[2];
        mestrokeColor.hex=rgb2hex(color[0],color[1],color[2]);
        c.editCommand('linecolor',mestrokeColor.hex);
        // this.body.update(''+this.getText(slider));

    },

    getText : function(slider){ 
       return slider.getValue();
    }
  }); 



  Ext.ux.SliderOpacityFill = Ext.extend(Ext.Tip, {
    minWidth: 10,
    offsets : [0, -10],
    init : function(slider){
        slider.on('dragstart', this.onSlide, this);
        slider.on('drag', this.onSlide, this);
        slider.on('dragend', this.hide, this);
        slider.on('destroy', this.destroy, this);
    },

    onSlide : function(slider){
        this.show();
        this.body.update(''+this.getText(slider)+'%');
        this.doAutoWidth();
        this.el.alignTo(slider.thumb, 'b-t?', this.offsets); 
        changeOpacity(this.getText(slider)/100, 'opacity-slider-fill');
        //--document.forms.formfilldata.fillopacity.value=this.getText(slider);
        mefillColor.opacity=this.getText(slider)/100;
        c.editCommand('fillopacity',mefillColor.opacity);
    },

    getText : function(slider){
        return slider.getValue();
    }
  });                                      
  Ext.ux.SliderOpacityStroke = Ext.extend(Ext.Tip, {
    minWidth: 10,
    offsets : [0, -10],
    init : function(slider){
        slider.on('dragstart', this.onSlide, this);
        slider.on('drag', this.onSlide, this);
        slider.on('dragend', this.hide, this);
        slider.on('destroy', this.destroy, this);
    },

    onSlide : function(slider){
        this.show();
        this.body.update(''+this.getText(slider)+'%');
        this.doAutoWidth();
        this.el.alignTo(slider.thumb, 'b-t?', this.offsets); 
        changeOpacity(this.getText(slider)/100, 'opacity-slider-stroke');
        //--document.forms.formstrokedata.strokeopacity.value=this.getText(slider);
        mestrokeColor.opacity=this.getText(slider)/100; 
        c.editCommand('lineopacity',mestrokeColor.opacity);
    },

    getText : function(slider){
        return slider.getValue();
    }
  }); 

  Ext.ux.SliderWidth = Ext.extend(Ext.Tip, {
    minWidth: 10,
    offsets : [0, -10],
    init : function(slider){
        slider.on('dragstart', this.onSlide, this);
        slider.on('drag', this.onSlide, this);
        slider.on('dragend', this.hide, this);
        slider.on('destroy', this.destroy, this);
    },

    onSlide : function(slider){
        this.show();
        this.body.update(''+this.getText(slider)+'px');
        this.doAutoWidth();
        this.el.alignTo(slider.thumb, 'b-t?', this.offsets); 
        Ext.get('width-slider-stroke-mask').applyStyles({'width':this.getText(slider)+'px'});
        //--document.forms.formstrokedata.strokewidth.value=this.getText(slider);
        mestrokeColor.width=this.getText(slider);  
        c.editCommand('linewidth',mestrokeColor.width);
    },

    getText : function(slider){
        return slider.getValue();
    }
  }); 




                                     
//===================================
//===================================

function select(select,action,type){  
 var id=select.id;
 if(type==0){var text='lineal';}   
 if(type==1){var text='radial';}  
 if(type==2){var text='no';}  
 // && mode_render_fill!=type
 if(action==0 && mode_render_fill!=type)
  {
   Ext.get(id).applyStyles({'background-position':'0 12px'});  
    

  }
 if(action==1 && mode_render_fill!=type)
  {
   Ext.get(id).applyStyles({'background-position':'0 0'}); 
   
  } 
 if(action==2)
  { 
   mode_render_fill=type; 
   if(id.indexOf('fill')!=-1)
    {
      Ext.get(prevselect_fill).applyStyles({'background-position':'0 12px'});
      prevselect_fill=id; 
      //--document.forms.formfilldata.fillgradient.value=text;
    }else{ 
    
      Ext.get(prevselect_stroke).applyStyles({'background-position':'0 12px'}); 
      prevselect_stroke=id;
      //--document.forms.formstrokedata.strokegradient.value=text;
    }  
   Ext.get(id).applyStyles({'background-position':'0 0'});
   
 
  }  
} 

function changeOpacity(opacity, id)
 {  
       var object = document.getElementById(id).style;  
       object.opacity = (opacity );
       object.MozOpacity = (opacity);  
       object.KhtmlOpacity = (opacity);  
       object.filter = "alpha(opacity=" + parseFloat(opacity*100) + ")";  
 } 

 //print() function will just create a window similar to the default alert function within the page.
//Arguments
// txt  - The message that appears in the box.
// title - The title of the box(OPTIONAL) 

/*
if(typeof console != 'object') {
console = {};
console.log = function(){return false;};
}                


/////////////////
var Docs = function(){
return {
init : function(){
var loading = Ext.get('loading');
var mask = Ext.get('loading-mask');
mask.setOpacity(.1);
mask.shift({
xy:loading.getXY(),
width:loading.getWidth(),
height:loading.getHeight(),
remove:true,
duration:1,
opacity:.8,
easing:'bounceOut',
callback : function(){
loading.fadeOut({duration:.1,remove:true});
}
});
}
};
}();
Ext.onReady(Docs.init, Docs, true);
 */  